bullet = class:new()

function bullet:init(x,y,kind,damage,speed,accuracy)
	--[[essential]]
	self.name = "bullet"
	self.startx = x
    self.starty = y
	self.x = x
	self.y = y
	self.width = 10
	self.height = 10
	self.center = 5
	self.remove = false
	--[[attributes]]
	self.kind = kind
	self.damage = damage
    self.speed = speed
    self.accuracy = accuracy
    self.angle = math.atan2((mousey - self.starty + 5 + math.random(-self.accuracy,self.accuracy)), (mousex - self.startx + 5 + math.random(-self.accuracy,self.accuracy)))
    self.life = 2
    if kind == "rocket" then
    	self.explode = true
    end
    if kind  == "grenade" then
    	self.explode = true
    	self.life = 0.6
    end
    if kind == "fire" then
    	self.life = 0.3
    	self.fire = true
    end
    self.timer = 0
    --[[targeting]]
    self.targetx = mousex
    self.targety = mousey
end
function bullet:update(dt)
	--[[movement]]
	self.center = self.width/2
	self.xspeed = self.speed * math.cos(self.angle)
    self.yspeed = self.speed * math.sin(self.angle)
	self.x = self.x + self.xspeed*dt
	self.y = self.y + self.yspeed*dt
	
	if self.kind == "rocket" then
		self.speed = self.speed + 150*dt
	end
	if self.kind == "grenade" then
		self.speed = self.speed - 150*dt
	end
	if self.kind == "fire" then
		self.x = self.x - 20*dt
		self.y = self.y - 20*dt
		self.width = self.width + 40*dt
		self.height = self.height + 40*dt
	end
	--[[anti-lag]]
	self.timer = self.timer + 1*dt
	if self.timer >= self.life then
		if self.kind == "grenade" then
			table.insert(objects, explosion:new(self.x-5,self.y-5,self.damage))
		end
		self.remove = true
	end
	
	--[[collision]]
	for i,v in pairs(objects) do
		if v.name == "zombie" then
			if collision(self.x,self.y,self.width,self.height,v.x,v.y,v.width,v.height) then
				v.health = v.health - self.damage
				score = score + self.damage
				if self.fire then
					v.fire = true
				end
				if self.kind == "grenade" or self.kind == "rocket" then
					table.insert(objects, explosion:new(self.x-5,self.y-5,self.damage))
				end
				self.remove = true
			end
		end
	end
end
function bullet:draw()
	love.graphics.setColor(255,255,255)
	if physicsdebug then
		love.graphics.rectangle("fill",self.x,self.y,self.width,self.height)
	end
	if self.kind == "bullet" then
		love.graphics.draw(bulletimg,self.x+self.center,self.y+self.center,self.angle, 1,1, self.center, self.center)
	elseif self.kind == "fire" then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(flameimg,self.x+self.center,self.y+self.center,self.angle, self.width/20,self.height/20, self.center, self.center)
	elseif self.kind == "rocket" then
		love.graphics.draw(rocketimg,self.x+self.center,self.y+self.center,self.angle, 1,1, self.center, self.center)
	elseif self.kind == "grenade" then
		love.graphics.draw(grenadeimg,self.x+self.center,self.y+self.center,self.angle, 1,1, self.center, self.center)
	end
end