function game_load()
	gamestate = "game"
	
    score = 0
    highscore = 1000
    --[[if love.filesystem.exists("highscore") then
    	highscore = tonumber(love.filesystem.read("highscore"))
    else
    	highscore = 1000
    end]]
    
    paused = false
    gameover = false
    
    deathreason = "none"
    deathreasonnumber = math.random(1,#deathmessage.explosion)
    
    pace = 6
    itempace = 15
    pacetimer = 0
    itempacetimer = 0
    physicsdebug = false

	survivaltimer = {}
	survivaltimer.halfseconds = 0
	survivaltimer.seconds = 0
	survivaltimer.minutes = 0
	survivaltimer.ticking = true

    objects = {}
    blocks = {}
    area = {}

	gradientlevel = 1

	mouseingame = true
	
	loadmap("map1", "main")
	
	playsound(menumusic)
end
function loadmap(map, gamemode)
	local config = love.filesystem.read("maps/"..map.."/config.txt")
	local s = split(config, ";")
	for i = 1, #s do
		local s2 = split(s[i], ":")
		if s2[1] == "name" then
			mapname = s2[2]
		end
		if s2[1] == "author" then
			mapauthor = s2[2]
		end
		if s2[1] == "block" then
			table.insert(blocks, block:new(tonumber(s2[2]),tonumber(s2[3]),tonumber(s2[4]),tonumber(s2[5]),s2[6],s2[7]))
		end
		if s2[1] == "area" then
			table.insert(area, area:new(tonumber(s2[2]),tonumber(s2[3]),tonumber(s2[4]),tonumber(s2[5]),s2[6],s2[7]))
		end
		if s2[1] == "player" then
			table.insert(objects, player:new(tonumber(s2[2]),tonumber(s2[3])))
		end
		if s2[1] == "zombie" then
			table.insert(objects, zombie:new(tonumber(s2[2]),tonumber(s2[3]),s2[4]))
		end
		if s2[1] == "drop" then
			table.insert(objects, drop:new(tonumber(s2[2]),tonumber(s2[3]),s2[4]))
		end
	end
end
function game_update(dt)
	if survivaltimer.ticking then
		survivaltimer.halfseconds = survivaltimer.halfseconds + 0.5*dt
		if survivaltimer.halfseconds >= 0.5 then
			survivaltimer.seconds = survivaltimer.seconds + 1
			survivaltimer.halfseconds = 0
		end
		if survivaltimer.seconds >= 60 then
			survivaltimer.minutes = survivaltimer.minutes + 1
			survivaltimer.seconds = 0
		end
	end
	if score > highscore then
		highscore = score
	end
	if gameover then 
		paused = true
		love.filesystem.write("highscore",highscore)
	end
	updatephysics(dt)
	pacetimer = pacetimer + 1*dt
	if pacetimer >= pace then
	   	table.insert(objects, zombie:new(math.random(-500,500),math.random(-500,500),"normal"))
	   	pacetimer = 0
	   	if pace > 2 then
	   		pace = pace - 0.1
	   	end
	end
	itempacetimer = itempacetimer + 1*dt
	if itempacetimer >= itempace then
	   	table.insert(objects, drop:new(math.random(-500,500),math.random(-500,500),math.random(1,#weapons)))
	   	itempacetimer = 0
	end
	if not paused then
		for i, v in pairs(objects) do
			v:update(dt)
		end
	end
	for i = #objects, 1, -1 do
		if objects[i].remove then
			table.remove(objects, i)
		end
	end
end
function game_draw()
	love.graphics.setColor(255,255,255)
	love.graphics.push()
    for i,v in pairs(objects) do
    	if v.name == "player" then
    		if paused then
    			love.graphics.translate(-v.x+(windowWidth/2),-v.y+(windowHeight/2))
    		else
    			love.graphics.translate(-mousex-10+(windowWidth/2),-mousey-10+(windowHeight/2))
    		end
    		if not physicsdebug then
		    	love.graphics.setColor(255,255,255,255)
		    else
		    	love.graphics.setColor(255,255,255,100)
		   	end
			love.graphics.draw(layer1img,-500,-500)
    		love.graphics.setColor(255,255,255,255)
			if physicsdebug then
	    		for x = -1000, 1000, 100 do
					for y = -1000, 1000, 100 do
					    love.graphics.print(x,x,y,0,fontsize,fontsize)
						love.graphics.print(y,x+30,y,0,fontsize,fontsize)
					end
				end
			end
    	end
   		v:draw()
   		if v.name == "player" then 
   			for i = 1, gradientlevel do 
   				love.graphics.draw(gradientimg,v.x+v.width/2-gradientimg:getWidth()/4,v.y+v.height/2-gradientimg:getHeight()/4,0,0.5,0.5)
   			end
   		end
    end
    if not physicsdebug then
    	love.graphics.setColor(255,255,255,255)
    else
    	love.graphics.setColor(255,255,255,100)
   	end
    love.graphics.draw(layer2img,-500,-500)
    love.graphics.setColor(255,255,255,255)
   	for i,v in pairs(blocks) do
   		v:draw()
   	end
    love.graphics.pop()
    for i,v in pairs(objects) do
    	if v.name == "player" then
    	   	love.graphics.setColor(255,255,255)
   			love.graphics.draw(crosshairimg,mousex-v.x+windowWidth/2,mousey-v.y+windowHeight/2,0,1,1,crosshairimg:getWidth()/2,crosshairimg:getHeight()/2)
			love.graphics.draw(hudimg,0,0)	
		  	love.graphics.print(v.weaponclip, 350, 245,0,fontsize+.6,fontsize+.6)
   		   	love.graphics.print(v.weaponammo, 350, 265,0,fontsize+.6,fontsize+.6)
   		   	love.graphics.print(weapons[v.weapon]["name"], 315, 210,0,fontsize,fontsize)
   		    love.graphics.print("score: "..score,90,5,0,fontsize,fontsize)
   		    love.graphics.print("highscore: "..highscore,240,5,0,fontsize,fontsize)
   		    love.graphics.print(survivaltimer.minutes..":"..survivaltimer.seconds,190,0,0,fontsize,fontsize)
   		    love.graphics.draw(hpbackimg,58,300-39-2)
   	   		love.graphics.setColor(255,0,0)
   			love.graphics.rectangle("fill",60,300-39,v.health,28)
   		    if v.health <= 6 then else
   		    	love.graphics.setColor(255,255,255)
   		  	    love.graphics.drawq(hpbarimg,hpbarimgquads[1],60,300-39)
   		  		love.graphics.drawq(hpbarimg,hpbarimgquads[3],60+v.health-6,300-39)
   		  		for i = 6, v.health-6 do
   		  	  		love.graphics.drawq(hpbarimg,hpbarimgquads[2],60+i,300-39)
   		  		end
   		  	end
   		end
   	end
	if gameover then
		love.graphics.setColor(100,100,100,100)
		love.graphics.rectangle("fill",0,0,windowWidth,windowHeight)
		love.graphics.setColor(255,255,255)
		if deathreason == "explosion" then
			love.graphics.print(deathmessage.explosion[deathreasonnumber],0,200,0,fontsize,fontsize)
		elseif deathreason == "zombie" then
			love.graphics.print(deathmessage.zombie[deathreasonnumber],0,200,0,fontsize,fontsize)
		end
	end
end
function game_keypressed(k,u)
	for i,v in ipairs(objects) do
		if v.name == "player" then
			v:keypressed(k,u)
		end
	end
	if k == "9" then
		gradientlevel = gradientlevel - 1
	elseif k == "0" then
		gradientlevel = gradientlevel + 1
	end
	if k == "escape" then
		if not gameover then
			paused = not paused
		end
	end
	if k == "/" then
		physicsdebug = not physicsdebug
	end
end
function split( _sInput,_sDelimiter )
	local tReturn = {}
	local delimiter = string.gsub( _sDelimiter,"([%^%$%(%)%%%.%[%]%*%+%-%?])","%%%a" )
	local searchPattern = "([^"..delimiter.."]+)"..delimiter.."?"
	for match in string.gmatch( _sInput,searchPattern ) do
		table.insert( tReturn,match )
	end
	return tReturn
end