player = class:new()

function player:init(x,y)
	--[[essential]]
	self.name = "player"
	self.x = x or 0
	self.y = y or 0
	self.cx = x or 0
	self.cy = y or 0
	self.width = 20
	self.height = 20
	self.center = 10
	self.angle = 0
	self.remove = false
	self.xspeed = 0
	self.yspeed = 0
	--[[attributes]]
	self.health = 100
	self.walkspeed = 130 --130
	self.fireratetimer = 0
	self.reloadtimer = 0
	self.winduptimer = 0
	self.weapon = 1
	self.reloading = false
	self.firstshot = false
	self.weaponclip = weapons[self.weapon]["clip"]
	self.weaponammo = weapons[self.weapon]["maxammo"]
	self.reason = "none"
end
function player:update(dt)
	self.angle = math.atan2(mousey - self.y, mousex - self.x)
	
	if mouseisdown then
		self:fireweapon(dt)
	else
		self.firstshot = false
		self.winduptimer = 0
	end
	if self.weaponclip == 0 or self.reloading and self.weaponammo ~= 0 then
		self.reloading = true
		self.reloadtimer = self.reloadtimer + 1*dt
		if self.reloadtimer >= weapons[self.weapon]["reloadrate"] then
			self.weaponclip = weapons[self.weapon]["clip"]
			self.weaponammo = self.weaponammo - self.weaponclip
			
			self.reloadtimer = 0
			self.reloading = false
		end
	end
	
	if self.health <= 0 then
		survivaltimer.ticking = false
		deathreason = self.reason
		gameover = true
	end
	if love.keyboard.isDown("w") then
		self.yspeed = -self.walkspeed
	elseif love.keyboard.isDown("s") then
		self.yspeed = self.walkspeed
	else
		self.yspeed = 0
	end
	if love.keyboard.isDown("a") then
		self.xspeed = -self.walkspeed
	elseif love.keyboard.isDown("d") then
		self.xspeed = self.walkspeed
	else
		self.xspeed = 0
	end
end
function player:draw()
	love.graphics.setColor(255,255,255)
	if physicsdebug then
		love.graphics.rectangle("fill",self.x,self.y,self.width,self.height)
	end
	love.graphics.draw(playerimg,self.x+self.center,self.y+self.center,self.angle, 1,1, self.center, self.center)
	if self.reloading then
		love.graphics.print("Reloading!",self.x,self.y,0,fontsize,fontsize)
	end
	if mouseisdown then
        love.graphics.draw(flashimg,math.cos(self.angle)*20+self.x+self.center, math.sin(self.angle)*20+self.y+self.center, self.angle,1,1,flashimg:getWidth()/2, flashimg:getHeight()/2)
    end
end
function player:keypressed(k,u)
	if k == "r" then
		self.reloading = true
	end
	if k == "=" then
		self:switchweapon(self.weapon+1)
	end
	if k == "-" then
		self:switchweapon(self.weapon-1)
	end
end
function player:fireweapon(dt)
	self.fireratetimer = self.fireratetimer + 1*dt
	if self.winduptimer == 0 then
		if weapons[self.weapon]["name"] == "flamethrower" then
			playsound(flameswindsnd)
		elseif weapons[self.weapon]["name"] == "minigun" then
			playsound(minigunwindsnd)
		end
	end
	self.winduptimer = self.winduptimer + 1*dt
	if (self.fireratetimer >= weapons[self.weapon]["firerate"] or not self.firstshot) and (not reloading) and self.weaponclip ~= 0 and self.winduptimer >= weapons[self.weapon]["windup"] then
		table.insert(objects, bullet:new(self.x+playerimg:getWidth()/2-5, self.y+playerimg:getHeight()/2-5,weapons[self.weapon]["kind"],weapons[self.weapon]["damage"],weapons[self.weapon]["speed"],weapons[self.weapon]["accuracy"]))
		self.weaponclip = self.weaponclip -1
		self.fireratetimer = 0
		if weapons[self.weapon]["name"] == "flamethrower" then
			love.audio.stop(flameswindsnd)
			playsound(flamesnd)
		elseif weapons[self.weapon]["name"] == "rifle" then
			playsound(riflesnd) 
		elseif weapons[self.weapon]["name"] == "rpg" then
			playsound(rpgsnd)
		elseif weapons[self.weapon]["name"] == "machine gun" then
			love.audio.stop(minigunwindsnd)
			playsound(machinegunsnd)
		elseif weapons[self.weapon]["name"] == "minigun" then
			playsound(minigunsnd)
		else
			playsound(pistolsnd)
		end
		self.firstshot = true
	end
end
function player:switchweapon(weaponnumber)
	self.reloading = false
	self.weapon = weaponnumber
	self.weaponclip = weapons[self.weapon]["clip"]
	self.weaponammo = weapons[self.weapon]["maxammo"]
end
function player:muzzleflash(weapon)
end