zombie = class:new()

function zombie:init(x,y,kind)
	self.name = "zombie"
	self.x = x or 0
	self.y = y or 0
	self.kind = kind
	self.width = 20
	self.height = 20
	self.center = 10
	self.angle = 0
	self.remove = false
	self.xspeed = 0
	self.yspeed = 0
	self.health = 100
	self.fire = false
	self.speed = math.random(100,130) --70, 100 160
	self.static = false
	self.attacking = false
	self.waittimer = 0
	self.soundtimer = 0
	self:playsound()
	self.quad = math.random(1,#zombieimgquads)
end
function zombie:playsound()
	local random = math.random(1,#zombiesnd)
	playsound(zombiesnd[random])
end
function zombie:update(dt)
	for i,v in pairs(objects) do
		if v.name == "player" then
			self.angle = math.atan2(v.y - self.y, v.x - self.x)
		end
	end
	self.soundtimer = self.soundtimer + 1*dt
	if soundtimer == 4 then
		self.soundtimer = 0
		self:playsound()
	end
	if self.health < 1 then
		self.remove = true
		score = score + 100
	end
	if self.fire then
		self.health = self.health - 20*dt
	end
	self.xspeed = self.speed * math.cos(self.angle)
    self.yspeed = self.speed * math.sin(self.angle)
	for i,v in pairs(objects) do
		if v.name == "player" then
			if collision(self.x,self.y,self.width,self.height,v.x,v.y,v.width,v.height) then
				self.static = true
				self.waittimer = self.waittimer + 1*dt
				if self.waittimer >= 0.5 then
					self.static = false
					self.attacking = true
					self.waittimer = 0
				end
				if self.attacking then
					v.reason = "zombie"
					v.health = v.health - 20
					self.attacking = false
					playsound(hitsnd)
				end
			else
				self.static = false
				self.attacking = false
			end
		end
	end
end
function zombie:draw()
	love.graphics.setColor(255,255,255)
	if physicsdebug then
		love.graphics.rectangle("fill",self.x,self.y,self.width,self.height)
	end
	love.graphics.drawq(zombieimg,zombieimgquads[self.quad],self.x+self.center,self.y+self.center,self.angle, 1,1, self.center, self.center)
	if self.fire then
		love.graphics.draw(flameimg,self.x,self.y)
	end
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("fill",self.x,self.y-7,self.health/4,5)
end